<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>ZooTrace.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper.server</a> &gt; <span class="el_source">ZooTrace.java</span></div><h1>ZooTrace.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.zookeeper.server;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import org.apache.zookeeper.server.quorum.QuorumPacket;

/**
 * This class encapsulates and centralizes tracing for the ZooKeeper server.
 * Trace messages go to the log with TRACE level.
 * &lt;p&gt;
 * Log4j must be correctly configured to capture the TRACE messages.
 */
<span class="nc" id="L32">public class ZooTrace {</span>
    final static public long CLIENT_REQUEST_TRACE_MASK = 1 &lt;&lt; 1;

    final static public long CLIENT_DATA_PACKET_TRACE_MASK = 1 &lt;&lt; 2;

    final static public long CLIENT_PING_TRACE_MASK = 1 &lt;&lt; 3;

    final static public long SERVER_PACKET_TRACE_MASK = 1 &lt;&lt; 4;

    final static public long SESSION_TRACE_MASK = 1 &lt;&lt; 5;

    final static public long EVENT_DELIVERY_TRACE_MASK = 1 &lt;&lt; 6;

    final static public long SERVER_PING_TRACE_MASK = 1 &lt;&lt; 7;

    final static public long WARNING_TRACE_MASK = 1 &lt;&lt; 8;

    final static public long JMX_TRACE_MASK = 1 &lt;&lt; 9;

<span class="fc" id="L51">    private static long traceMask = CLIENT_REQUEST_TRACE_MASK</span>
            | SERVER_PACKET_TRACE_MASK | SESSION_TRACE_MASK
            | WARNING_TRACE_MASK;

    public static long getTextTraceLevel() {
<span class="fc" id="L56">        return traceMask;</span>
    }

    public static void setTextTraceLevel(long mask) {
<span class="fc" id="L60">        traceMask = mask;</span>
<span class="fc" id="L61">        Logger LOG = LoggerFactory.getLogger(ZooTrace.class);</span>
<span class="fc" id="L62">        LOG.info(&quot;Set text trace mask to 0x&quot; + Long.toHexString(mask));</span>
<span class="fc" id="L63">    }</span>

    public static boolean isTraceEnabled(Logger log, long mask) {
<span class="pc bpc" id="L66" title="3 of 4 branches missed.">        return log.isTraceEnabled() &amp;&amp; (mask &amp; traceMask) != 0;</span>
    }

    public static void logTraceMessage(Logger log, long mask, String msg) {
<span class="pc bpc" id="L70" title="1 of 2 branches missed.">        if (isTraceEnabled(log, mask)) {</span>
<span class="nc" id="L71">            log.trace(msg);</span>
        }
<span class="fc" id="L73">    }</span>

    static public void logQuorumPacket(Logger log, long mask,
            char direction, QuorumPacket qp)
    {
<span class="nc" id="L78">        return;</span>

        // if (isTraceEnabled(log, mask)) {
        // logTraceMessage(LOG, mask, direction + &quot; &quot;
        // + FollowerHandler.packetToString(qp));
        // }
    }

    static public void logRequest(Logger log, long mask,
            char rp, Request request, String header)
    {
<span class="nc bnc" id="L89" title="All 2 branches missed.">        if (isTraceEnabled(log, mask)) {</span>
<span class="nc" id="L90">            log.trace(header + &quot;:&quot; + rp + request.toString());</span>
        }
<span class="nc" id="L92">    }</span>
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>